/*
 * test.probe.c - generic probe routine for feeding ProbeScope.
 * 
 * R. E. Crandall, Scientific Computation Group
 * c. 1990 NeXT, Inc.  All Rights Reserved
 *
 * FIRST modify the routine getsignal() to generate your stereo
 * signal of choice.
 * Then compile with:
 * cc -O test.probe.c -o test.probe -lm
 * ensuring that the executable "probe" resides in ProbeScope's directory.
 * Then ProbeScope will launch the
 * executable "probe" automatically.
 */
 
#include<stdio.h>
#include<math.h>
#define MAX_SCOPE_BYTES (3*8192)  /* The 'scope never asks for more. */

short probe_data[MAX_SCOPE_BYTES];

void
getsignal(short *data, int numshorts) {
	int j;
	
	for(j=0;j<numshorts;j++) {
		if(j%2) data[j] = 10000*sin(j/32.0) + random()* (1e-6);
			else data[j] = 10000*(cos(j/32.0)-0.5);
	}
}
 
main() {
	int numbytes, numshorts;
	while(1) {	
		fread(&numbytes, sizeof(int), 1, stdin);
		fflush(stdin);	
		numshorts = numbytes/sizeof(short);
		getsignal(probe_data, numshorts);	
		fwrite(&probe_data, sizeof(short), numshorts, stdout);
		fflush(stdout);
	}
}


